import { DocumentNode } from "graphql";
import { ApolloClient } from 'vue-cli-plugin-apollo/graphql-client';
export declare type Primitive = string | Function | number | boolean | symbol | undefined | null;
export declare type DeepOmitHelper<T, K extends keyof T> = {
    [P in K]: T[P] extends infer TP ? TP extends Primitive ? TP : TP extends any[] ? DeepOmitArray<TP, K> : DeepOmit<TP, K> : never;
};
export declare type DeepOmit<T, K> = T extends Primitive ? T : DeepOmitHelper<T, Exclude<keyof T, K>>;
export declare type DeepOmitArray<T extends any[], K> = {
    [P in keyof T]: DeepOmit<T[P], K>;
};
export declare type Config = {
    graphql?: boolean;
    rest?: boolean;
    debug?: boolean;
    schema?: DocumentNode;
    schemaUrl?: string;
    apolloClient?: ApolloClient;
    stripTypename?: <T>(obj: T) => DeepOmit<T, "__typename">;
};
export declare type KeyValueString = {
    [key: string]: string;
};
export declare type KeyValueUnknown = {
    [key: string]: unknown;
};
export declare type UrlResolver = (params?: KeyValueString, collection?: boolean) => string;
export declare type ResolvingRESTOptions = {
    method: string;
    url: string | UrlResolver;
    params: unknown;
};
export declare type PropertyFunction<T> = () => T;
export declare type HttpMethod = 'get' | 'post' | 'put' | 'delete' | 'patch';
export declare type GraphQLErrorType = {
    extensions: {
        errorCode: number;
        message: string;
    };
};
export declare type GraphQLErrorBag = {
    graphQLErrors: GraphQLErrorType[];
};
export declare type EventType = {
    type: string;
    target: unknown;
    payload?: unknown;
};
export declare type EventSubscriber = {
    fired?: boolean;
    immediate: boolean;
    callback: (event: EventType) => void;
};
export declare type EventListeners = {
    [key: string]: EventSubscriber[];
};
//# sourceMappingURL=typings.d.ts.map